;-----------------------------------
; win64 macros
;-----------------------------------


; STR = a macro used to auto-define a strings
;	 inside invoke or instructions like this:
;
;	invoke	MessageBox,<STR "my message">, <STR "my caption">
;	mov	rax,<STR "A message string">
;
macro STR
	marg my_str
	
	.data
		@my_var		db	my_str,0
	.code
	
	exitm @my_var
endm


; TSTR = a macro used to define a unicode string or an ascii string
; depending on "_UNICODE" symbol beeing defined
; similar to _T() in C/C++
; 	use /d _UNICODE in command line or
; 	_UNICODE equ 1 in code

macro TSTR
	marg 	my_str
	
	.data
	
	#ifdef _UNICODE
		@offset du my_str,0
	#else
		@offset db my_str,0
	#endif
	
	.code
	
	exitm @offset
endm
